



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HDU 2094：产生冠军（拓扑排序）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HDU 2094：产生冠军（拓扑排序）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 01:38:25 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>产生冠军</h1>
<p><strong><strong>Time Limit: 1000/1000 MS (Java/Others)&nbsp;&nbsp;&nbsp;&nbsp;Memory Limit: 32768/32768 K (Java/Others)<br /><br />
Total Submission(s): 21762&nbsp;&nbsp;&nbsp;&nbsp;Accepted Submission(s): 9864</strong></strong></p>
<p><strong>Problem Description</strong></p>
<p>有一群人，打乒乓球比赛，两两捉对撕杀，每两个人之间最多打一场比赛。<br /><br />
球赛的规则如下：<br /><br />
如果A打败了B，B又打败了C，而A与C之间没有进行过比赛，那么就认定，A一定能打败C。<br /><br />
如果A打败了B，B又打败了C，而且，C又打败了A，那么A、B、C三者都不可能成为冠军。<br /><br />
根据这个规则，无需循环较量，或许就能确定冠军。你的任务就是面对一群比赛选手，在经过了若干场撕杀之后，确定是否已经实际上产生了冠军。</p>
<p><strong>Input</strong></p>
<p>输入含有一些选手群，每群选手都以一个整数n(n&lt;1000)开头，后跟n对选手的比赛结果，比赛结果以一对选手名字（中间隔一空格）表示，前者战胜后者。如果n为0，则表示输入结束。</p>
<p><strong>Output</strong></p>
<p>对于每个选手群，若你判断出产生了冠军，则在一行中输出“Yes”，否则在一行中输出“No”。</p>
<p><strong>Sample Input</strong></p>
<p>3</p>
<p>Alice Bob</p>
<p>Smith John</p>
<p>Alice Smith</p>
<p>5</p>
<p>a c</p>
<p>c d</p>
<p>d e</p>
<p>b e</p>
<p>a d</p>
<p>0</p>
<p><strong>Sample Output</strong></p>
<p>Yes</p>
<p>No</p>
<p><img referrerpolicy="no-referrer"src="https://img-blog.csdn.net/20180804111125202?watermark/2/text/aHR0cHM6Ly9ibG9nLmNzZG4ubmV0L3dhbmdfMTIzX3p5/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70"></p>
<h2>思路</h2>
<p>就是找有多少个名字的入度为1 。如果有一个，输出Yes，否则输出No。</p>
<h2>AC代码</h2>
<pre class="prettyprint linenums"><code>#include &lt;stdio.h&gt;<br />
#include &lt;string.h&gt;<br />
#include &lt;iostream&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;math.h&gt;<br />
#include &lt;limits.h&gt;<br />
#include &lt;map&gt;<br />
#include &lt;stack&gt;<br />
#include &lt;queue&gt;<br />
#include &lt;vector&gt;<br />
#define ll long long<br />
#define ms(a) memset(a,0,sizeof(a))<br />
#define pi acos(-1.0)<br />
#define INF 0x3f3f3f3f<br />
const double E=exp(1);<br />
const int maxn=1e3+10;<br />
using namespace std;<br />
char name1[maxn][maxn],name2[maxn][maxn];<br />
int vis[maxn];<br />
int main(int argc, char const *argv[])<br />
{<br />
	// ios::sync_with_stdio(false);<br />
	int n;<br />
	while(cin&gt;&gt;n&amp;&amp;n)<br />
	{<br />
		for(int i=0;i&lt;n;i++)<br />
		{<br />
			scanf("%s%s",name1[i],name2[i]);<br />
			vis[i]=1;<br />
		}<br />
		int ans=0;<br />
		for(int i=0;i&lt;n;i++)<br />
		{<br />
			for(int j=0;j&lt;n;j++)<br />
			{<br />
				// 如果胜利者在失败者那里出现了<br />
				if(strcmp(name1[i],name2[j])==0)<br />
					vis[i]=0;<br />
				// 去掉重复的获胜者名字<br />
				if(i!=j&amp;&amp;strcmp(name1[i],name1[j])==0)<br />
					vis[j]=0;<br />
			}<br />
			ans+=vis[i];<br />
		}<br />
		if(ans==1)<br />
			cout&lt;&lt;"Yes"&lt;&lt;endl;<br />
		else<br />
			cout&lt;&lt;"No"&lt;&lt;endl;<br />
	}<br />
	return 0;<br />
}</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7mvzkq.html">VirtualBox内ubuntu10&period;10系统和windows7 共享文件夹</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1kd609.html">Spring-boot 开发Web应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyo3xx8.html">LInux下修改 ~&sol;&period;bashrc 文件source ～&sol;&period;bashrc 后  shell 命令 失效 任何命令都显示 &OpenCurlyDoubleQuote; bash  XX  &colon;未找到命令&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e7djx9.html">UIView CALayer 的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvwxxo9.html">php中的匿名函数和闭包&lpar;closure&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kw7mr8.html">SU suspike命令学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p1w4k9.html">JavaScript的My97Date日期工具类的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvkx6zq.html">NopCommerce 数据库初始化</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vnmmo8.html">Force removing ActivityRecord，app died&comma; no saved state报错的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ok0z49.html">ios Object Encoding and Decoding with NSSecureCoding Protocol</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7myy21q.html">C&num;解leetcode 16&period; 3Sum Closest</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x44vg9.html">实现SQLServer数据库转成MYSQL数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/96po03n8.html">Let&rsquo;s do this！新手程序员的入门指南&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1pgwzq.html">&lbrack;HNOI 2010&rsqb;Bounce 弹飞绵羊</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zodnmvq.html">&lbrack;20190402&rsqb;Library Cache mutex&period;txt</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25j2jlq.html">loadrunner飞机订票系统从登陆订票退票登出的脚本实现代码调试通过</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvlwk38.html">xxx&period;jar或者xxx&period;war中没有主清单属性和spring-boot-maven-plugin的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1mgeg9.html">微信小程序跳转微信小程序新增配置项目 navigateToMiniProgramAppIdList</a>
		</li>
						<li><a href="https://www.batexi.com/a/9607zyn9.html">yum 安装时错误 Errno 14 Couldn&amp;&num;39&semi;t resolve host 解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1pl3l9.html">用D3&period;js画的人物关系demo</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1vp1m0q.html">深入理解Hadoop之HDFS架构</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppkldd9.html">简说Spring事务</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pmlznq.html">java中的值传递和引用传递用法详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2o7208.html">《剑指offer》第九题（用两个栈实现队列）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vp1d4q.html">消息&sol;事件&comma; 同步&sol;异步&sol;协程&comma; 并发&sol;并行  协程与状态机  &mdash;&mdash;从python asyncio引发的集中学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/953m2vz8.html">Linux忘记root登录密码解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv4pvxq.html">CentOS配置iptables规则并使其永久生效</a>
			</li>
						<li><a href="https://www.batexi.com/a/902joyoq.html">雷林鹏分享：C&num; 事件（Event）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pd0r08.html">mysql--------char 和 varchar 的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvrwxmq.html">『Re』知识工程作业&lowbar;主体识别</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
